#pragma once

#include <RobotAPI/libraries/armem/server/ltm/LongtermMemoryBase.h>
#include <RobotAPI/libraries/armem/server/query_proc/base.h>


namespace armarx::armem::server::query_proc::ltm
{
    static const base::QueryTarget queryTarget = query::data::QueryTarget::LTM;


    class EntityQueryProcessor :
        public base::EntityQueryProcessorBase<queryTarget, armem::wm::Entity, armem::wm::Entity>
    {
    };

    class ProviderSegmentQueryProcessor :
        public base::ProviderSegmentQueryProcessorBase <queryTarget, armem::wm::ProviderSegment, armem::wm::ProviderSegment, EntityQueryProcessor >
    {
    };

    class CoreSegmentQueryProcessor :
        public base::CoreSegmentQueryProcessorBase <queryTarget, armem::wm::CoreSegment, armem::wm::CoreSegment, ProviderSegmentQueryProcessor>
    {
    };

    class MemoryQueryProcessor :
        public base::MemoryQueryProcessorBase <queryTarget, armem::wm::Memory, armem::wm::Memory, CoreSegmentQueryProcessor >
    {
    };

}
